//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%480CA223007B.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%480CA223007B.cm

//## begin module%480CA223007B.cp preserve=no
//## end module%480CA223007B.cp

//## Module: MdefContainer%480CA223007B; Package body
//## Subsystem: XSModel::GlobalContainer%3E4293160205
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSModel/GlobalContainer/MdefContainer.cxx

//## begin module%480CA223007B.additionalIncludes preserve=no
//## end module%480CA223007B.additionalIncludes

//## begin module%480CA223007B.includes preserve=yes
//## end module%480CA223007B.includes

// MdefContainer
#include <XSModel/GlobalContainer/MdefContainer.h>
//## begin module%480CA223007B.declarations preserve=no
//## end module%480CA223007B.declarations

//## begin module%480CA223007B.additionalDeclarations preserve=yes
#include <XSstreams.h>
#include <XSUtil/Error/Error.h>
#include <sstream>
#include <iomanip>
#include <memory>
//## end module%480CA223007B.additionalDeclarations


//## Modelname: XSModel::GlobalContainer%3E42929A0210
namespace XSContainer {
    //## begin XSContainer%3E42929A0210.initialDeclarations preserve=yes
    //## end XSContainer%3E42929A0210.initialDeclarations

    // Class XSContainer::MdefContainer 

    //## begin XSContainer::MdefContainer::NOT_FOUND%4816302E01CB.attr preserve=no  public: static string {UC} string("hN#@xnNOT_FOUNDp!749w9q")
    const string MdefContainer::s_NOT_FOUND = string("hN#@xnNOT_FOUNDp!749w9q");
    //## end XSContainer::MdefContainer::NOT_FOUND%4816302E01CB.attr

    MdefContainer::MdefContainer()
      //## begin MdefContainer::MdefContainer%480CA2B80150_const.hasinit preserve=no
      //## end MdefContainer::MdefContainer%480CA2B80150_const.hasinit
      //## begin MdefContainer::MdefContainer%480CA2B80150_const.initialization preserve=yes
      : m_components()
      //## end MdefContainer::MdefContainer%480CA2B80150_const.initialization
    {
      //## begin XSContainer::MdefContainer::MdefContainer%480CA2B80150_const.body preserve=yes
      //## end XSContainer::MdefContainer::MdefContainer%480CA2B80150_const.body
    }


    MdefContainer::~MdefContainer()
    {
      //## begin XSContainer::MdefContainer::~MdefContainer%480CA2B80150_dest.body preserve=yes
         CompMap::iterator itComp = m_components.begin();
         CompMap::iterator itCompEnd = m_components.end();
         while (itComp != itCompEnd)
         {
            delete itComp->second.second;
            ++itComp;
         }
      //## end XSContainer::MdefContainer::~MdefContainer%480CA2B80150_dest.body
    }



    //## Other Operations (implementation)
    void MdefContainer::displayComponents () const
    {
      //## begin XSContainer::MdefContainer::displayComponents%480CB30400AF.body preserve=yes
       using namespace std; 
       
       if (m_components.empty())
          tcout << "No user-defined models" << endl;
       else
       {
          tcout << "-- Name ---- Type ----- Expresssion -----" << endl;
          ios_base::fmtflags saveFmt(tcout.flags());
          CompMap::const_iterator itComp = m_components.begin();
          CompMap::const_iterator itCompEnd = m_components.end();
          while (itComp != itCompEnd)
          {
             const string& type = itComp->second.first;           
             const string& name = itComp->first;
             const MathExpression* expr = itComp->second.second->generator();
             tcout << left << setw(12) << name << setw(5) << type
                   << expr->exprString() << endl;
             ++itComp;
          }
          tcout.flags(saveFmt);
       }
      //## end XSContainer::MdefContainer::displayComponents%480CB30400AF.body
    }

    string MdefContainer::removeComponent (const string& name)
    {
      //## begin XSContainer::MdefContainer::removeComponent%480CB3560065.body preserve=yes
       string compType(s_NOT_FOUND);
       CompMap::iterator itComp = m_components.find(name);
       if (itComp != m_components.end())
       {
          compType = itComp->second.first;
          delete itComp->second.second;
          m_components.erase(itComp);
       }
       return compType;
      //## end XSContainer::MdefContainer::removeComponent%480CB3560065.body
    }

    bool MdefContainer::addComponent (const string& name, const string& type, const string& expression, std::pair<Real,Real> eLimits)
    {
      //## begin XSContainer::MdefContainer::addComponent%480CBD43027C.body preserve=yes
       // Don't let in a name the same as not_found indicator.  It's extremely
       // unlikely anyone could match the not_found name accidentally.
       if (name == s_NOT_FOUND)
       {
          string err(name);
          err += " is an internally reserved name and is unavailable for mdefine.\n";
          throw YellowAlert(name); 
       }
              
       // Don't step on any pre-existing component.  Instead return
       // false and if calling function decides it's OK, it can call
       // removeComponent before calling this again.
       
       // Assume type has already been validated.
       CompMap::iterator itExisting = m_components.find(name);
       if (itExisting != m_components.end())
          return false;
       
       std::auto_ptr<MathExpression> expr(new MathExpression(eLimits,type));
       // This may throw
       expr->init(expression);
       XSCall<MathExpression>* callExpr = new XSCall<MathExpression>(expr.get());
       expr.release();
       m_components[name] = std::make_pair(type,callExpr);
       return true;
      //## end XSContainer::MdefContainer::addComponent%480CBD43027C.body
    }

    void MdefContainer::displayComponent (const string& name) const
    {
      //## begin XSContainer::MdefContainer::displayComponent%4810CF80021A.body preserve=yes
       using namespace std; 
       
       CompMap::const_iterator itComp = m_components.find(name);
       if (itComp != m_components.end())
       {
          ios_base::fmtflags saveFmt(tcout.flags());
          const string& type = itComp->second.first;           
          const string& name = itComp->first;
          const MathExpression* expr = itComp->second.second->generator();
          tcout << left << setw(12) << name << setw(5) << type
                << expr->exprString() << endl;
          tcout.flags(saveFmt);
       }
       else
       {
          tcout << "\"" << name << "\" is not a user defined model" << endl;
       }
      //## end XSContainer::MdefContainer::displayComponent%4810CF80021A.body
    }

    MdefContainer::CompPair MdefContainer::getComponent (const string& name) const
    {
      //## begin XSContainer::MdefContainer::getComponent%48162A9A013C.body preserve=yes
       CompPair result(s_NOT_FOUND,static_cast<XSCall<MathExpression>*>(0));
       // Require an exact name match, partially name not good enough.  Assume
       // case has already been lowered.
       CompMap::const_iterator itFound = m_components.find(name);
       if (itFound != m_components.end())
       {
          result = itFound->second;
       }
       return result;
      //## end XSContainer::MdefContainer::getComponent%48162A9A013C.body
    }

    // Additional Declarations
      //## begin XSContainer::MdefContainer%480CA2B80150.declarations preserve=yes
      //## end XSContainer::MdefContainer%480CA2B80150.declarations

} // namespace XSContainer

//## begin module%480CA223007B.epilog preserve=yes
//## end module%480CA223007B.epilog
